;Menu Lockout Program
;by Doug Melton
;based on TSR source code by A.E.
;10-31-97 through 11-10-97


#include usgard.h

.org 0
.db "TSR Menu Lockout by DM",0

;;;;;;;;;;;;;;;;;;;password code
	call	CLEARLCD
        ld      (CURSOR_ROW), de                 ;reset cursor to 0,0
        set     3, (IY+5)                        ;display white on black

        ld      hl, &Prot
        call    D_ZT_STR

        ld      de, PASWRD
        ld      c, K_ENTER
PWKeyLoop:
	call	GET_KEY
	or	a
        jr      z, PWKeyLoop
	
        ld      hl, (PROGRAM_ADDR)
        add     hl, de
        inc     de
        cp      (hl)
        jr      z, CheckEnter
	inc	c
CheckEnter:
	cp	K_ENTER
        jr      nz, PWKeyLoop
	cp	c
        ret     nz                                ;exit--invalid pw
;;;;;;;;;;;;;;;;;;;
ProgStart:
        call    CLEARLCD  ;de is cleared
        ld      (CURSOR_ROW), de                 ;reset cursor to 0,0

        ld      hl, &TitleTxt
        call    D_ZT_STR

        res     3, (IY+5)                        ;display black on white
        call    &DisplayMenu

        ld      de, $3A06
        ld      (CURSOR_X), de
        ld      hl, &MenuF1Txt
        call    D_ZM_STR
        ld      a, 27
        ld      (CURSOR_X), a
        ld      hl, &MenuF2Txt

ProgMenu:
        push    hl
        ld      hl, VIDEO_MEM+$0090
        ld      bc, 16*6-1
        call    OTH_CLEAR
        pop     hl
        call    D_ZM_STR
ProgMenuLoop:
        call    GET_KEY
        cp      K_EXIT
        ret     z
        cp      K_F2
        jp      z, &ChangePW
        cp      K_F1
        jr      nz, ProgMenuLoop

ToggleLock:
        ld      hl, (PROGRAM_ADDR)
        push    hl
        call    CHECK_APPEND
        pop     de
        jr      z, InstallTSR
        jr      c, RemoveTSR
        ld      hl, &RemoveErrorTxt
ShowMessage:
        ld      de, $0900
        ld      (CURSOR_X), de
        jr      ProgMenu

InstallTSR:
        ld      hl, &TSR_Handler
        ld      bc, TSR_End-TSR_Handler
        call    APPEND
        jr      c, InstallError
        push    hl

        ld      d, h
        ld      e, l
        ld      bc, TSR_Vars-TSR_Handler
        add     hl, bc
        ex      de, hl
        inc     hl
        ld      (hl), e
        inc     hl
        ld      (hl), d                         ;put address of TSR variables in TSR

        pop     hl
        call    INT_INSTALL
        jr      nc, InstallOK
        call    UNAPPEND
InstallError:
        ld      hl, &InstallErrorTxt
        jr      ShowMessage
InstallOK:
        ld      hl, &InstallOKTxt
        jr      ShowMessage

RemoveTSR:
        call    INT_REMOVE
        call    UNAPPEND
        ld      hl, &RemoveOKTxt
        jr      ShowMessage

TSR_Handler:
        ld      hl, 0           ;this should be changed to TSR_Vars
        ld      a, (LAST_KEY)
        ld      bc, 2
        cpir
        ret     nz
TSR_PushExit:
        ld      a, K_EXIT
        ld      (KEY_0), a
        ld      (LAST_KEY), a
        ret
TSR_Vars:
        .db     K_PLUS, K_XVAR
TSR_End:

;******************* Change Password routine ************************
;Description:   Changes the Password
;Parameters:    none
;Destroys:      ?
ChangePW:
        ld      de, $0900
        ld      (CURSOR_X), de
        ld      hl, &EnterPWTxt
        call    D_ZM_STR
        ld      b, 8
        ld      hl, &PASWRD
ChangePWLoop:
        push    hl
        call    GET_KEY
        pop     hl
        or      a
        jr      z, ChangePWLoop
        ld      (hl), a
        inc     hl
        cp      K_ENTER
        jr      z, ChangePWDone
        djnz    ChangePWLoop
        ld      a, K_ENTER
        ld      (hl), a

ChangePWDone:
        ld      hl, &PWChangedTxt
        jr      ShowMessage

;********************* Display Menu routine *************************
;Description:   Draws the menu bar at the bottom of the screen
;Parameters:    none
;Destroys:      a, bc, hl

DisplayMenu:
        ld      hl, VIDEO_MEM+$380
        ld      b, 32
DisplayMenuLoop1:
        ld      (hl), $FF
        inc     hl
        djnz    DisplayMenuLoop1

        ld      b, 36
        ld      a, %11000000
        or      a
DisplayMenuLoop2:
        ld      (hl), a
        inc     hl
        inc     hl
        inc     hl
        rra
        cp      3
        jr      nz, DisplayMenuLoop2
        ld      a, $C0
        dec     hl
        dec     hl
        djnz    DisplayMenuLoop2

        ld      a, $FE
        ld      (VIDEO_MEM+$38F), a
        ld      (VIDEO_MEM+$39F), a
        ret
;********************************************************************

TitleTxt:
 .db "  TSR Menu Lockout   ",0

MenuF1Txt:
 .db "Lock",0
MenuF2Txt:
 .db "Chg Pw",0

EnterPWTxt:
 .db "Enter Password...",0

PWChangedTxt:
 .db "Password Changed",0

InstallOKTxt:
 .db "Menu Lock ON",0

InstallErrorTxt:
 .db "Error Installing!",0

RemoveOKTxt:
 .db "Menu Lock OFF",0

RemoveErrorTxt:
 .db "Error Removing!",0

Prot:   .db " PASSWORD PROTECTED  ",0

;scancodes of password keys, last one should be K_ENTER
;following password is LOCK:
PASWRD: .db $24,$0C,$1E,$2C,K_ENTER,0,0,0,0

.end
